// Shadow.c
// OpenGL SuperBible
// Demonstrates simple planar shadows
// Program by Richard S. Wright Jr.

#include "../Common/OpenGLSB.h"  // System and OpenGL Stuff
#include "../Common/gltools.h"       // gltools library

#include "stdio.h"
#include <commctrl.h>
#include  <commdlg.h>
#include <windows.h>
void Anisotropic_filter()
{		
	int g_nMaxAnisotropy;
	
	glGetIntegerv(GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT,&g_nMaxAnisotropy);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAX_ANISOTROPY_EXT, g_nMaxAnisotropy - 0.1);		
}
void Trilinein_filter()
{
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR);
}
void Bilinein_filter()
{
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
}
///////////////////////
// 5 
GLuint filtr=-1;
char *TextureFileName=strdup("tex7.tga");
GLuint pyramid_buffer_ID;
GLuint room_buffer_ID;
	 float x1=0.166666666;//66666666666666666666667f;
	float x2=0.8333333333;//3333333333333333333333f;


	const float ROOM_SIZE=50.0f;
	
	float room_pixels[]={
		// 
			0.0f,0.0f,
			0.0f,1.0f,0.0f,
			-ROOM_SIZE,-ROOM_SIZE,-ROOM_SIZE,

			1.0f,0.0f,
			0.0f,1.0f,0.0f,
			-ROOM_SIZE,-ROOM_SIZE,ROOM_SIZE,

			1.0f,1.0f,
			0.0f,1.0f,0.0f,
			ROOM_SIZE,-ROOM_SIZE,ROOM_SIZE,

			0.0f,1.0f,
			0.0f,1.0f,0.0f,
			ROOM_SIZE,-ROOM_SIZE,-ROOM_SIZE,
			
		// 
			0.0f,1.0f,
			0.0f,-1.0f,0.0f,
			-ROOM_SIZE,ROOM_SIZE,-ROOM_SIZE,

			0.0f,0.0f,
			0.0f,-1.0f,0.0f,
			ROOM_SIZE,ROOM_SIZE,-ROOM_SIZE,

			1.0f,0.0f,
			0.0f,-1.0f,0.0f,
			ROOM_SIZE,ROOM_SIZE,ROOM_SIZE,

			1.0f,1.0f,
			0.0f,-1.0f,0.0f,
			-ROOM_SIZE,ROOM_SIZE,ROOM_SIZE,
			// 
			0.0f,0.0f,
			1.0f,0.0f,0.0f,
			-ROOM_SIZE,ROOM_SIZE,-ROOM_SIZE,

			1.0f,0.0f,
			1.0f,0.0f,0.0f,
			-ROOM_SIZE,ROOM_SIZE,ROOM_SIZE,

			1.0f,1.0f,
			1.0f,0.0f,0.0f,
			-ROOM_SIZE,-ROOM_SIZE,ROOM_SIZE,

			0.0f,1.0f,
			1.0f,0.0f,0.0f,
			-ROOM_SIZE,-ROOM_SIZE,-ROOM_SIZE,

			// 
			1.0f,0.0f,
			-1.0f,0.0f,0.0f,
			ROOM_SIZE,ROOM_SIZE,ROOM_SIZE,

			0.0f,0.0f,
			-1.0f,0.0f,0.0f,
			ROOM_SIZE,ROOM_SIZE,-ROOM_SIZE,

			0.0f,1.0f,
			-1.0f,0.0f,0.0f,
			ROOM_SIZE,-ROOM_SIZE,-ROOM_SIZE,

			1.0f,1.0f,
			-1.0f,0.0f,0.0f,
			ROOM_SIZE,-ROOM_SIZE,ROOM_SIZE,

		// 
			0.0f,0.0f,
			0.0f,0.0f,1.0f,
			ROOM_SIZE,ROOM_SIZE,-ROOM_SIZE,

			1.0f,0.0f,
			0.0f,0.0f,1.0f,
			-ROOM_SIZE,ROOM_SIZE,-ROOM_SIZE,

			1.0f,1.0f,
			0.0f,0.0f,1.0f,
			-ROOM_SIZE,-ROOM_SIZE,-ROOM_SIZE,

			0.0f,1.0f,
			0.0f,0.0f,1.0f,
			ROOM_SIZE,-ROOM_SIZE,-ROOM_SIZE,

			// 
				0.0f,0.0f,
			0.0f,0.0f,-1.0f,
			-ROOM_SIZE,ROOM_SIZE,ROOM_SIZE,

			1.0f,0.0f,
			0.0f,0.0f,-1.0f,
			ROOM_SIZE,ROOM_SIZE,ROOM_SIZE,

			1.0f,1.0f,
			0.0f,0.0f,-1.0f,
			ROOM_SIZE,-ROOM_SIZE,ROOM_SIZE,

			0.0f,1.0f,
			0.0f,0.0f,-1.0f,
			-ROOM_SIZE,-ROOM_SIZE,ROOM_SIZE,
	};
	 float pixels[]={
		//
			x1,0.0f,
			0.0f,1.0f,-6.0f,
			-2.0f,3.0f,-2.0f,



			x2,0.0f,
			0.0f,1.0f,-6.0f,
			2.0f,3.0f,-2.0f,

					
			1.0f,1.0f,
			0.0f,1.0f,-6.0f,
			3.0f,-3.0f,-3.0f,

			0.0f,1.0f,
			0.0f,1.0f,-6.0f,
			-3.0f,-3.0f,-3.0f,
	
/////////////////////
//
			0.0f,0.0f,
			0.0f,-1.0f,0.0f,
			-3.0f,-3.0f,-3.0f,

			1.0f,0.0f,
			0.0f,-1.0f,0.0f,
			3.0f,-3.0f,-3.0f,

			1.0f,1.0f,
			0.0f,-1.0f,0.0f,
			3.0f,-3.0f,3.0f,

			0.0f,1.0f,
			0.0f,-1.0f,0.0f,
			-3.0f,-3.0f,3.0f,
			
//////////////////////
//

			0.0f,0.0f,
			0.0f,1.0f,0.0f,
			-2.0f,3.0f,-2.0f,

			1.0f,0.0f,
			0.0f,1.0f,0.0f,
			-2.0f,3.0f,2.0f,

			1.0f,1.0f,
			0.0f,1.0f,0.0f,
			2.0f,3.0f,2.0f,

			0.0f,1.0f,
			0.0f,1.0f,0.0f,
			2.0f,3.0f,-2.0f,
			//////////////////////

//

		x1,0.0f,
		0.0f,1.0f,6.0f,
		2.0f,3.0f,2.0f,

		x2,0.0f,
		0.0f,1.0f,6.0f,
		-2.0f,3.0f,2.0f,

	

		1.0f,1.0f,
		0.0f,1.0f,6.0f,
		-3.0f,-3.0f,3.0f,


		0.0f,1.0f,
		0.0f,1.0f,6.0f,
		3.0f,-3.0f,3.0f,
	


//////////////////////////////////
//
		x1,0.0f,
		6.0f,1.0f,0.0f,
		2.0f,3.0f,-2.0f,
	
	
		

		x2,0.0f,
		6.0f,1.0f,0.0f,
		2.0f,3.0f,2.0f,
		
	
	
		

		1.0f,1.0f,
		6.0f,1.0f,0.0f,
		3.0f,-3.0f,3.0f,
	
	

		0.0f,1.0f,
		6.0f,1.0f,0.0f,
		3.0f,-3.0f,-3.0f,
	
		
	
///////////////////////////////

	//	glNormal3f(-6.0f,1.0f,0.0f);
//		glVertex3f(-2.0f,3.0f,-2.0f);
//		glVertex3f(-3.0f,-3.0f,-3.0f);
//		glVertex3f(-3.0f,-3.0f,3.0f);
//		glVertex3f(-2.0f,3.0f,2.0f);
//
		x1,0.0f,
		-6.0f,1.0f,0.0f,
		-2.0f,3.0f,2.0f,
	

		x2,0.0f,
		-6.0f,1.0f,0.0f,
		-2.0f,3.0f,-2.0f,
	
	

		1.0f,1.0f,
		-6.0f,1.0f,0.0f,
		-3.0f,-3.0f,-3.0f,

		0.0f,1.0f,
		-6.0f,1.0f,0.0f,
	
		-3.0f,-3.0f,3.0f,
	

	};

GLuint space_tex;
GLboolean glVersion15=false;
GLboolean glBuffersSupported=false;
PFNWGLGETEXTENSIONSSTRINGARBPROC glBindBuffer=NULL;
//PFNWGLGETEXTENSIONSSTRINGARBPROC glGenBuffers=NULL;
typedef    void   (*GLGENBUFFERSPROC)(GLuint,GLuint *);
GLGENBUFFERSPROC glGenBuffers=NULL;
PFNWGLGETEXTENSIONSSTRINGARBPROC glMapBuffer=NULL;
PFNWGLGETEXTENSIONSSTRINGARBPROC glUnmapBuffer=NULL;
PFNWGLGETEXTENSIONSSTRINGARBPROC glBufferData=NULL;
PFNWGLGETEXTENSIONSSTRINGARBPROC glBufferSubData=NULL;
PFNWGLGETEXTENSIONSSTRINGARBPROC glDeleteBuffer=NULL;

GLuint texture;
struct TEXTURE{
	GLbyte *pTexture;
	GLint width;
	GLint height;
	GLint comp;
	GLuint format;
	GLuint nTexture;
}Texture;

	GLubyte p[]={
		255,0,0,   255,255,255,   255,0,0,	 255,0,0,
		0,0,0,   255,255,255,   255,0,0,	 255,0,0,
		0,0,0,   255,255,255,   255,0,0,	 255,0,0
		};

void SetTexture(TEXTURE &Texture,char *FileName)
{
	/*glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
glGenTextures(1, &space_tex);
glBindTexture(GL_TEXTURE_2D, space_tex);

	 gluBuild2DMipmaps(GL_TEXTURE_2D, 3,
                  4,
                  4,
                  GL_RGB, GL_UNSIGNED_BYTE,
                  p);*/

//	 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
//glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
//glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);

	glEnable(GL_TEXTURE_2D);
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
glGenTextures(1,&(Texture.nTexture));
glBindTexture(GL_TEXTURE_2D,Texture.nTexture);
Texture.pTexture=gltLoadTGA(FileName,&(Texture.width),&(Texture.height),&(Texture.comp),&(Texture.format));

//glTexImage2D(GL_TEXTURE_2D,0,Texture.comp,Texture.width,Texture.height,0,Texture.format,GL_UNSIGNED_BYTE,Texture.pTexture);

gluBuild2DMipmaps(GL_TEXTURE_2D,Texture.comp,Texture.width,Texture.height,Texture.format, GL_UNSIGNED_BYTE,Texture.pTexture);

free(Texture.pTexture);
	 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);



//	glTexImage2D(GL_TEXTURE_2D,0,3,/*width*/4,4,0,GL_RGB,GL_UNSIGNED_INT,p);
/*	GLenum err;
	err=glGetError();

		switch (err)
	{
	case GL_NO_ERROR:
		printf("Set texture success\n");
		break;
	default:
		printf("Cannot set texture\n");
		break;
	}
*/
}

//////////////





		int k;

struct CPoint{
	float x,y,z;
};
	const float SX=150.0f;
	const float SZ=200.0f;
	const float SY=200.0f;



float GRAPH_QUALITY = 20;

#define SCENE_COLOR 0
#define PYRAMID_COLOR 1
#define SPHERE_COLOR 2
#define LIGHT0_COLOR 3
#define LIGHT1_COLOR 4
#define CLEAR_COLOR 5
#define MAX_COLORS 6

GLint Colors[MAX_COLORS][4];
GLboolean IsOrtho = false;
GLboolean IsSolid = true;
GLboolean Spot    = false;
GLfloat dx = 0.0f, dy = 0.0f, dz = -50.0f, ddz = 0.1f;
GLfloat alpha = 0.0f, theta = 0.0f;
GLfloat SceneAngleY=0.0f,SceneAngleX=0.0f;

	GLfloat ambient[]={0.1f,0.1f,0.1f,1.0f};
	GLfloat color[]={0.0f,0.5f,0.0f,1.0f};
	GLfloat green[]={0.0f,1.0f,0.0f,1.0f};
	GLfloat white[]={1.0f,1.0f,1.0f,1.0f};


GLfloat pos[]={0.0f,20.0f,0.0f,1.0f};
GLfloat pos1[]={-100.0f,-20.0f,0.0f,1.0f};


// Rotation amounts
static GLfloat xRot = 0.0f;
static GLfloat yRot = 0.0f;

// These values need to be available globally
// Light values and coordinates
GLfloat  ambientLight[] = { 0.1f, 0.1f, 0.1f, 1.0f };
GLfloat  diffuseLight[] = { 0.8f, 0.8f, 0.8f, 1.0f };
GLfloat  specular[] = { 0.3f, 0.3f, 0.3f, 1.0f};
GLfloat  lightPos[] = { 0.0f, 100.0f, 100.0f, 0.0f };
GLfloat  specref[] =  { 1.0f, 1.0f, 1.0f, 1.0f };


GLfloat  ambientLight2[] = { 0.3f, 0.3f, 0.6f, 1.0f };
GLfloat  diffuseLight2[] = { 0.3f, 0.3f, 0.6f, 1.0f };
GLfloat  specular2[] = { 0.3f, 0.3f, 0.6f, 1.0f};




// Transformation matrix to project shadow
GLTMatrix shadowMat;
GLTMatrix shadowMat2;


void PlaneParam(int p1,int p2, int p3, GLdouble * coeffic, CPoint * kub)
{
	coeffic[0] = kub[p1].y * (kub[p2].z - kub[p3].z) + kub[p2].y * (kub[p3].z - kub[p1].z) + kub[p3].y * (kub[p1].z - kub[p2].z);
	coeffic[1] = kub[p1].z * (kub[p2].x - kub[p3].x) + kub[p2].z * (kub[p3].x - kub[p1].x) + kub[p3].z * (kub[p1].x - kub[p2].x);
	coeffic[2] = kub[p1].x * (kub[p2].y - kub[p3].y) + kub[p2].x * (kub[p3].y - kub[p1].y) + kub[p3].x * (kub[p1].y - kub[p2].y);
	coeffic[3] = -kub[p1].x * (kub[p2].y*kub[p3].z - kub[p3].y*kub[p2].z)
				 -kub[p2].x * (kub[p3].y*kub[p1].z - kub[p1].y*kub[p3].z) 
				 -kub[p3].x * (kub[p1].y*kub[p2].z - kub[p2].y*kub[p1].z); 				
}


void SetFiltr()
{
	switch (filtr)
		{
		case 0:
	
			Anisotropic_filter();
		//SetTexture(Texture,TextureFileName);
			break;
		case 1:
			Trilinein_filter();
			break;
		case 2:
			Bilinein_filter();
			break;
			
		};//
}
////////////////////////////////////////////////
// This function just specifically draws the jet
void DrawJet(int nShadow)
  {


  GLTVector3 vNormal; // Storeage for calculated surface normal

  // Nose Cone /////////////////////////////
  // Set material color, note we only have to set to black
  // for the shadow once


	glMatrixMode(GL_MODELVIEW);
	

	glPushMatrix();
	const float G_SIZE=20.0f;
	glScalef(G_SIZE,G_SIZE,G_SIZE);
	//if (!IsOrtho) 
	//	glTranslatef(0.0f, 0.0f, -200.0f);
	//glRotatef(theta, 0.0f, 0.0f, 1.0f);
		

	//	gluLookAt(0.0f,50.0f,200.0f,
	//		0.0f,0.0f,0.0f,
	//		0.0f,1.0f,0.0f);
	glTranslatef(dx,dy,dz);

	
	//glRotatef(SceneAngleX,0.0f,0.0f,-1.0f*sinf(SceneAngleY/360*3.1415926545));
	static const float cutoff=25;
	static const float cutoff180=180;
	static const float exponent=10.0f;
	
	

	//glRotatef(SceneAngleY,0.0f,1.0f,0.0f);
	//glRotatef(SceneAngleX,1.0f,0.0f,1.0f);	

	glPushMatrix();
	glRotatef(alpha,0.0f,1.0f,0.0f);
	//glTranslatef(-5.0f,0.0f,0.0f);
	
	//glMaterialiv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,Colors[SPHERE_COLOR]);
	//glMaterialiv(GL_FRONT,GL_SPECULAR,Colors[SPHERE_COLOR]);
	//glMaterialfv(GL_FRONT,GL_SHININESS,&Shininess);
	//SetTexture(Texture,"tex7.tga");
	 glEnable(GL_TEXTURE_GEN_S);
	 glEnable(GL_TEXTURE_GEN_T);
	 glEnable(GL_TEXTURE_GEN_R);
	 //glEnable(GL_TEXTURE_GEN_Q);
	 SetFiltr();
	 	
	 glTexGeni(GL_S,GL_TEXTURE_GEN_MODE,GL_OBJECT_LINEAR);
	 glTexGeni(GL_T,GL_TEXTURE_GEN_MODE,GL_OBJECT_LINEAR);
	 glTexGeni(GL_R,GL_TEXTURE_GEN_MODE,GL_OBJECT_LINEAR);
	 glTexGeni(GL_Q,GL_OBJECT_PLANE,GL_SPHERE_MAP);
	if (IsSolid) glutSolidSphere(2.0f,GRAPH_QUALITY,GRAPH_QUALITY);
		else glutWireSphere(2.0f,GRAPH_QUALITY,GRAPH_QUALITY);
	glPopMatrix();
	glDisable(GL_TEXTURE_GEN_T);
	glDisable(GL_TEXTURE_GEN_S);
	glDisable(GL_TEXTURE_GEN_R);
	glDisable(GL_TEXTURE_GEN_Q);



	glPushMatrix();
	glRotatef(theta,0.0f,1.0f,0.0f);

	glTranslatef(-5.0f,0.0f,0.0f);
	
	//glDisable(GL_LIGHTING);
	//glCullFace(GL_FRONT_AND_BACK);
	//glMaterialiv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,Colors[PYRAMID_COLOR]);
	//glMaterialiv(GL_FRONT,GL_SPECULAR,Colors[PYRAMID_COLOR]);

	
	static float indexes[]={
		0,1,2,3
	};

GLenum err;
//	glEnableClientState(GL_COLOR_ARRAY);
	if  (glBuffersSupported)
	{
		__asm{
			push pyramid_buffer_ID;
			push GL_ARRAY_BUFFER;
			call glBindBuffer;
		}
		glInterleavedArrays(GL_T2F_N3F_V3F,sizeof(float)*8,0);
		SetFiltr();
		glDrawArrays(GL_QUADS,0,4*6);
		__asm{
			push room_buffer_ID;
			push GL_ARRAY_BUFFER;
			call glBindBuffer;
		}
	

		glInterleavedArrays(GL_T2F_N3F_V3F,sizeof(float)*8,0);
		SetFiltr();
		glDrawArrays(GL_QUADS,0,4*6);
	}
	else
	{

		glInterleavedArrays(GL_T2F_N3F_V3F,sizeof(float)*8,pixels);
SetFiltr();
		glDrawArrays(GL_QUADS,0,4*6);

		glInterleavedArrays(GL_T2F_N3F_V3F,sizeof(float)*8,room_pixels);
SetFiltr();
		glDrawArrays(GL_QUADS,0,4*6);
		
	}
	

	//glVertexPointer(3,GL_FLOAT,0,pixels);
	//glBegin(GL_POINTS);
	//glEnd();

	/*err=glGetError();

		switch (err)
	{
	case GL_NO_ERROR:
		printf("success\n");
		break;
	case GL_INVALID_ENUM:
		printf("invalid enum\n");
		break;
	case GL_INVALID_VALUE:
		printf("invalid value\n");
		break;
	case GL_INVALID_OPERATION:
		printf("invalid operation\n");
		break;
	}*/

//		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);


//		glBindTexture(GL_TEXTURE_2D,Texture.nTexture );
//		if (!glIsTexture(Texture.nTexture)) printf("not_texture");

//		SetTexture(Texture,"tex7.tga");

	/*
		err=glGetError();

		switch (err)
	{
	case GL_NO_ERROR:
		printf("success\n");
		break;
	case GL_INVALID_ENUM:
		printf("invalid enum\n");
		break;
	case GL_INVALID_VALUE:
		printf("invalid value\n");
		break;
	case GL_INVALID_OPERATION:
		printf("invalid operation\n");
		break;
	}

		*/

	//glEnableClientState(GL_VERTEX_ARRAY);
	//glDrawArrays(GL_TRIANGLES,0,4);

	
	//glBegin(GL_TRIANGLES);
	//glEnd();
	/*
	glBegin(GL_TRIANGLE_FAN);
	
		glNormal3f(0.0f,-1.0f,0.0f);
		glVertex3f(-3.0f,-3.0f,-3.0f);
		glVertex3f(3.0f,-3.0f,-3.0f);
		glVertex3f(3.0f,-3.0f,3.0f);
		glVertex3f(-3.0f,-3.0f,3.0f);
	glEnd();
	glBegin(GL_TRIANGLE_FAN);
		glNormal3f(0.0f,1.0f,0.0f);
		glVertex3f(-2.0f,3.0f,-2.0f);
		glVertex3f(-2.0f,3.0f,2.0f);
		glVertex3f(2.0f,3.0f,2.0f);
		glVertex3f(2.0f,3.0f,-2.0f);
	glEnd();
	glBegin(GL_TRIANGLE_FAN);
		glNormal3f(0.0f,1.0f,6.0f);
		glVertex3f(-2.0f,3.0f,2.0f);
		glVertex3f(-3.0f,-3.0f,3.0f);
		glVertex3f(3.0f,-3.0f,3.0f);
		glVertex3f(2.0f,3.0f,2.0f);
	glEnd();
	glBegin(GL_TRIANGLE_FAN);
		glNormal3f(0.0f,1.0f,-6.0f);
		glVertex3f(-2.0f,3.0f,-2.0f);
		glVertex3f(2.0f,3.0f,-2.0f);
		glVertex3f(3.0f,-3.0f,-3.0f);
		glVertex3f(-3.0f,-3.0f,-3.0f);
	glEnd();
	
	glBegin(GL_TRIANGLE_FAN);
		glNormal3f(-6.0f,1.0f,0.0f);
		glVertex3f(-2.0f,3.0f,-2.0f);
		glVertex3f(-3.0f,-3.0f,-3.0f);
		glVertex3f(-3.0f,-3.0f,3.0f);
		glVertex3f(-2.0f,3.0f,2.0f);
	glEnd();
	glBegin(GL_QUADS);
		glNormal3f(6.0f,1.0f,0.0f);
		glVertex3f(2.0f,3.0f,-2.0f);
		glVertex3f(2.0f,3.0f,2.0f);
		glVertex3f(3.0f,-3.0f,3.0f);
		glVertex3f(3.0f,-3.0f,-3.0f);
	glEnd();
*/
  


	glPopMatrix();
	
	
	



/*

	glEnable(GL_LIGHT0);
	
	glLightfv(GL_LIGHT0,GL_POSITION,pos);
	static GLfloat dir[]={0.0f,-1.0f,0.0f};
	glLightfv(GL_LIGHT0,GL_SPOT_DIRECTION,dir);
	glLightiv(GL_LIGHT0,GL_DIFFUSE,Colors[LIGHT0_COLOR]);
	glLightiv(GL_LIGHT0,GL_SPECULAR,Colors[LIGHT0_COLOR]);

	if (Spot)
	{
		glLightfv(GL_LIGHT0,GL_SPOT_CUTOFF,&cutoff);
		glLightfv(GL_LIGHT0,GL_SPOT_EXPONENT,&exponent);
	}
	else
	{
		glLightfv(GL_LIGHT0,GL_SPOT_CUTOFF,&cutoff180);
	}


	glEnable(GL_LIGHT1);
	static GLfloat dir1[]={1.0f,0.0f,0.0f};

	glLightfv(GL_LIGHT1,GL_POSITION,pos1);
	glLightfv(GL_LIGHT1,GL_SPOT_DIRECTION,dir1);
	glLightiv(GL_LIGHT1,GL_DIFFUSE,Colors[LIGHT1_COLOR]);
	glLightiv(GL_LIGHT1,GL_SPECULAR,Colors[LIGHT1_COLOR]);
	
	if (Spot)
	{
		glLightfv(GL_LIGHT1,GL_SPOT_CUTOFF,&cutoff);
		glLightfv(GL_LIGHT0,GL_SPOT_EXPONENT,&exponent);
	}
	else
	{
		glLightfv(GL_LIGHT1,GL_SPOT_CUTOFF,&cutoff180);
	}

/*	glTranslatef(-dx,-dy,-dz);

	
	glMaterialiv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,&(Colors[SCENE_COLOR][0]));
	glMaterialiv(GL_FRONT,GL_SPECULAR,&(Colors[SCENE_COLOR][0]));
	const float SIZE=100.0f;
	const float SIZER=100.0f/float(GRAPH_QUALITY)+1.0f;

	glNormal3f(0.0f,1.0f,0.0f);
	for (float n=-SIZE;n<SIZE;n+=SIZER)
	{
		for (float m=-SIZE; m<SIZE; m+=SIZER)
		{
			glBegin(GL_POLYGON);
				glVertex3i(n,-30,m);
				glVertex3i(n,-30,m+SIZER);
				glVertex3i(n+SIZER,-30,m+SIZER);
				glVertex3i(n+SIZER,-30,m);
				
			glEnd();
		}
	}

*/
	

	glPopMatrix();

}

// Called to draw scene
void RenderScene(void)
    {

		float xRot2=xRot,yRot2=yRot;
    // Clear the window with current clearing color
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glPushMatrix();

	//SetTexture(Texture,"tex7.tga");
	// glRotatef(xRot2, 1.0f, 0.0f, 0.0f);
 //   glRotatef(yRot2, 0.0f, 1.0f, 0.0f);
	
//	glTranslatef(dx,dy,dz);
//	glutSolidTetrahedron();
	DrawJet(0);
	glPopMatrix();
	/*
	int Situation=0;
	while (Situation<=2)
	{
	glPushMatrix();
	
	
	    // Draw the ground, we do manual shading to a darker green
    // in the background to give the illusion of depth
    // Now rotate the jet around in the new flattend space
    glRotatef(xRot2, 1.0f, 0.0f, 0.0f);
    glRotatef(yRot2, 0.0f, 1.0f, 0.0f);
	glDisable(GL_CLIP_PLANE0);
	glDisable(GL_CLIP_PLANE1);
	glDisable(GL_CLIP_PLANE2);
	glDisable(GL_CLIP_PLANE3);
	glDisable(GL_CLIP_PLANE4);

		switch (Situation)
		{
		case 0:

			glCullFace(GL_BACK);
			glDisable(GL_DEPTH_TEST);
			glBegin(GL_QUADS);
				glColor4f(0.5f,0.5f,1.0f,0.9f);
				glNormal3f(1.0f,0.0f,0.0f);
				glVertex3f(-SX,SY,SZ);
				glVertex3f(-SX,-SY,SZ);
				glVertex3f(-SX,-SY,-SZ);
				glVertex3f(-SX,SY,-SZ);
	

				//glNormal3f(-1.0f,0.0f,0.0f);
				//glVertex3f(-SX,SY,-SZ);
				//glVertex3f(-SX,-SY,-SZ);
				//glVertex3f(-SX,-SY,SZ);
				//glVertex3f(-SX,SY,SZ);
				
				
				
			glEnd();
			
			glScalef(-1.0f,1.0f,1.0f);
			glTranslatef(SX*2,0.0f,0.0f);
			
			glCullFace(GL_FRONT);
			k=130;
			break;
		case 1:

			//glScalef(-1.0f,1.0f,1.0f);
			//glTranslatef(-SX*2,0.0f,0.0f);
			//k=130;
		  
			//break;
		case 2:
			//glScalef(1.0f,0.0f,0.0f);
			k=0;
			glCullFace(GL_BACK);
			break;
			
		}



	glEnable(GL_LIGHTING);
	
	


	






	const float SM=0.1f;
	const float SX2=SX+SM,SY2=SY+SM,SZ2=SZ+SM;
	CPoint kub[8] = {{-SX2,-SY2,-SZ2},{-SX2,-SY2, SZ2},{SX2,-SY2,SZ2},{SX2,-SY2,-SZ2,},{-SX2,SY2,-SZ2},{-SX2,SY2, SZ2},{SX2,SY2,SZ2},{SX2,SY2,-SZ2,}};						    //  
	/*CPoint kub2[8] = {{-1,-1,-1},{-1,-1, 1},{1,-1,1},{40,-40,-40,},{-40,40,-40},{-40,40, 40},{40,40,40},{40,40,-40,}};	
	glClearColor(0.0,0.0,0.0,1.0);			//  
	glPolygonMode(GL_FRONT_AND_BACK, Gradient);
	glEnable(GL_COLOR_MATERIAL);
	glEnable(GL_NORMALIZE);
	glEnable(GL_DEPTH_TEST);
	
	GLfloat atmoColor[4] = {0.8, 0.8, 1.0, 0.005};
	glFogfv (GL_FOG_COLOR, atmoColor);
	//glFogf (GL_FOG_START, 0.5);
	//glFogf (GL_FOG_END, 0.5);
	glFogf (GL_FOG_DENSITY, 0.005);
	glEnable(GL_FOG);

//---------------------------------------------------------------------------//
	GLTVector3 points_w1[3] = {{-40,40,40},{-40,-40,40},{-40,40, -40}};
	GLTVector3 points_w2[3] = {{40,40,-40},{-40,40, -40},{40,-40,-40}};
	GLTVector3 points_w3[3] = {{40,40,40},{40,40,-40},{40,-40,40}};
	GLTVector3 points_f[3] = {{-40,-40,-40},{-40,-40, 40},{40,-40,40}};
	
	GLfloat lightPos_f[] = {0.0, 38.0,0.0,1.0};
//---------------------------------------------------------------------------//*/
/*	GLdouble coeffic_f[4] = {0.0,0.0,0.0,0.0};
	GLdouble coeffic_w1[4] = {0.0,0.0,0.0,0.0};
	GLdouble coeffic_w2[4] = {0.0,0.0,0.0,0.0};
	GLdouble coeffic_w3[4] = {0.0,0.0,0.0,0.0};
	GLdouble coeffic_w4[4] = {0.0,0.0,0.0,0.0};
		
	PlaneParam(0,1,2,coeffic_f,kub);
	PlaneParam(4,5,1,coeffic_w1,kub);
	PlaneParam(7,4,0,coeffic_w2,kub);
	PlaneParam(2,6,7,coeffic_w3,kub);
	PlaneParam(1,5,6,coeffic_w4,kub);
	
	glClipPlane(GL_CLIP_PLANE0,coeffic_f);
	glClipPlane(GL_CLIP_PLANE1,coeffic_w1);
	glClipPlane(GL_CLIP_PLANE2,coeffic_w2);
	glClipPlane(GL_CLIP_PLANE3,coeffic_w3);
	glClipPlane(GL_CLIP_PLANE4,coeffic_w4);
	glEnable(GL_CLIP_PLANE0);
	glEnable(GL_CLIP_PLANE1);
	glEnable(GL_CLIP_PLANE2);
	glEnable(GL_CLIP_PLANE3);
	glEnable(GL_CLIP_PLANE4);




	glEnable(GL_DEPTH_TEST);
      glBegin(GL_QUADS);

        glColor3ub(0,255,k);
		glNormal3f(0.0f,1.0f,0.0f);
        glVertex3f(SX, -SY, -SZ);
        glVertex3f(-SX, -SY, -SZ);
        glColor3ub(0,255,k);
        glVertex3f(-SX, -SY, SZ);
        glVertex3f(SX, -SY, SZ);



		glNormal3f(0.0f,-1.0f,0.0f);

		glColor3ub(0,255,k);
		glVertex3f(SX, SY, SZ);
		glVertex3f(-SX, SY, SZ);
		 glColor3ub(0,255,k);
		
		glVertex3f(-SX, SY, -SZ);
        glVertex3f(SX, SY, -SZ);
        
        
        
        

		//////////////////////////////
		//glColor3ub(k,132,k);
		glNormal3f(0.0f,0.0f,1.0f);
		glVertex3f(-SX,SY,-SZ);
		glVertex3f(-SX,-SY,-SZ);
		glVertex3f(SX,-SY,-SZ);
		glVertex3f(SX,SY,-SZ);

	

    glEnd();

    glDisable(GL_LIGHTING);

  glDisable(GL_DEPTH_TEST);

		



    // Get ready to draw the shadow and the ground
    // First disable lighting and save the projection state
  
    glPushMatrix();

    // Multiply by shadow projection matrix
    glMultMatrixf((GLfloat *)shadowMat);

    // Now rotate the jet around in the new flattend space
    //glRotatef(xRot2, 1.0f, 0.0f, 0.0f);
   // glRotatef(yRot2, 0.0f, 1.0f, 0.0f);

    // Pass true to indicate drawing shadow
    DrawJet(1); 

    // Restore the projection to normal
    glPopMatrix();


	
    // Get ready to draw the shadow and the ground
    // First disable lighting and save the projection state
    glDisable(GL_DEPTH_TEST);
    glDisable(GL_LIGHTING);

		


    glPushMatrix();

    // Multiply by shadow projection matrix
    glMultMatrixf((GLfloat *)shadowMat2);

    // Now rotate the jet around in the new flattend space
    //glRotatef(xRot2, 1.0f, 0.0f, 0.0f);
    //glRotatef(yRot2, 0.0f, 1.0f, 0.0f);

    // Pass true to indicate drawing shadow
    DrawJet(1); 

    // Restore the projection to normal
    glPopMatrix();


    // Save the matrix state and do the rotations
    glPushMatrix();
    // Draw jet at new orientation, put light in correct position
    // before rotating the jet
    glEnable(GL_LIGHTING);
	glEnable(GL_DEPTH_TEST);
    glLightfv(GL_LIGHT0,GL_POSITION,lightPos);
    //glRotatef(xRot2, 1.0f, 0.0f, 0.0f);
    //glRotatef(yRot2, 0.0f, 1.0f, 0.0f);

    DrawJet(0);

    // Restore original matrix state
    glPopMatrix();  


	glDisable(GL_LIGHTING);
    // Draw the light source
    glPushMatrix();
    glTranslatef(lightPos[0],lightPos[1], lightPos[2]);
    glColor3ub(255,255,0);
    glutSolidSphere(5.0f,10,10);
    glPopMatrix();
	glEnable(GL_LIGHTING);
    // Restore lighting state variables
    glEnable(GL_DEPTH_TEST);

	glPopMatrix();
    // Display the results

  
	Situation++;
	}
	*/
	  glutSwapBuffers();
}

// This function does any needed initialization on the rendering
// context. 
void SetupRC()
    {
    // Any three points on the ground (counter clockwise order)
	const float SY2=SY;
	const float SZ2=SZ;
    GLTVector3 points[3] = {{ -30.0f, -SY2, -20.0f },
                            { -30.0f, -SY2, 20.0f },
                            { 40.0f, -SY2, 20.0f }};
	GLTVector3 points2[3] = {{ -30.0f, SY2, -SZ2 },
                            { -30.0f, -SY2, -SZ2 },
                            { 40.0f, -SY2, -SZ2 }};

    glEnable(GL_DEPTH_TEST);  // Hidden surface removal
    glFrontFace(GL_CCW);    // Counter clock-wise polygons face out
    glEnable(GL_CULL_FACE);   // Do not calculate inside of jet

    // Setup and enable light 0
    glLightfv(GL_LIGHT0,GL_AMBIENT,ambientLight);
    glLightfv(GL_LIGHT0,GL_DIFFUSE,diffuseLight);
    glLightfv(GL_LIGHT0,GL_SPECULAR,specular);
    glLightfv(GL_LIGHT0,GL_POSITION,lightPos);
    glEnable(GL_LIGHT0);

    // Enable color tracking
    glEnable(GL_COLOR_MATERIAL);
  
	
    // Set Material properties to follow glColor values
   // glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);

    // All materials hereafter have full specular reflectivity
    // with a high shine
	glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE,diffuseLight);
    glMaterialfv(GL_FRONT, GL_SPECULAR,specref);
    glMateriali(GL_FRONT,GL_SHININESS,128);

    // Light blue background
    glClearColor(1.0f, 1.0f, 1.0f, 1.0f );

    // Calculate projection matrix to draw shadow on the ground
 //   gltMakeShadowMatrix(points, lightPos, shadowMat);
//	gltMakeShadowMatrix(points2, lightPos, shadowMat2);

		for (int n=0; n<MAX_COLORS;n++)
		{
			
		//	Colors[n][1]=0x3fffffff;
			Colors[n][2]=0x7fffffff;
		//	Colors[n][3]=0x7fffffff;
		}


	//glEnable(GL_BLEND);
	//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
//	glEnable(GL_NORMALIZE);
//	glEnable(GL_FOG);
	//float col[]={1.0f,1.0f,1.0f,1.0f};
	//glFogfv(GL_FOG_COLOR,col);
	//float den=0.0009;
	//glFogf(GL_FOG_DENSITY,den);
	char *version=(char* )glGetString(GL_VERSION);
	printf(version);
	int v1,v2,v3;
	char c;
	sscanf(version,"%i%c%i",&v1,&c,&v2);
	if ((v1>=1)&&(v2>=5)&&(c=='.'))
	{
		glVersion15=true;
	}
	if ((!glVersion15)&&(!gltIsExtSupported("GL_ARB_vertex_buffer_object")))
	{
		exit(0);
	}

	glBuffersSupported=true;
	if (!(glBindBuffer=(PFNWGLGETEXTENSIONSSTRINGARBPROC)wglGetProcAddress("glBindBufferARB"))) glBuffersSupported=false;
	if (!(glGenBuffers=(GLGENBUFFERSPROC)wglGetProcAddress("glGenBuffersARB"))) glBuffersSupported=false;
	if (!(glMapBuffer=(PFNWGLGETEXTENSIONSSTRINGARBPROC)wglGetProcAddress("glMapBufferARB"))) glBuffersSupported=false;
	if (!(glUnmapBuffer=(PFNWGLGETEXTENSIONSSTRINGARBPROC)wglGetProcAddress("glUnmapBufferARB"))) glBuffersSupported=false;
	if (!(glBufferData=(PFNWGLGETEXTENSIONSSTRINGARBPROC)wglGetProcAddress("glBufferDataARB"))) glBuffersSupported=false;
	if (!(glBufferSubData=(PFNWGLGETEXTENSIONSSTRINGARBPROC)wglGetProcAddress("glBufferSubDataARB"))) glBuffersSupported=false;
	if (!(glDeleteBuffer=(PFNWGLGETEXTENSIONSSTRINGARBPROC)wglGetProcAddress("glDeleteBuffersARB"))) glBuffersSupported=false;
	
	if (glBuffersSupported)
	{
		GLuint vsize=sizeof(GLfloat)*8*6*4;
		float * mypixels=&(pixels[0]);
		__asm{
			push offset pyramid_buffer_ID;
			push 1;
			call glGenBuffers;

			push pyramid_buffer_ID;
			push GL_ARRAY_BUFFER;
			call glBindBuffer;

			push GL_STATIC_DRAW;
			push mypixels;
			push 768;
			push GL_ARRAY_BUFFER;
			call glBufferData;
			
		}

		 mypixels=&(room_pixels[0]);
		__asm{
			//   
			push offset room_buffer_ID;
			push 1;
			call glGenBuffers;

			push room_buffer_ID;
			push GL_ARRAY_BUFFER;
			call glBindBuffer;

			push GL_STATIC_DRAW;
			push mypixels;
			push 768;
			push GL_ARRAY_BUFFER;
			call glBufferData;
			
		}
		
		//glGenBuffers(1,&pyramid_buffer_ID);
		//glBindBuffer(GL_ARRAY_BUFFER,pyramid_buffer_ID);
		//glBufferData(GL_ARRAY_BUFFER,4*6*sizeof(GLfloat),
		//	pixels,
		//	GL_STATIC_DRAW);
	}
	else
	{
		glEnableClientState(GL_NORMAL_ARRAY);
		glEnableClientState(GL_VERTEX_ARRAY);
		glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	}
	glEnable(GL_LIGHTING);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_TEXTURE_2D);
	 glEnable(GL_AUTO_NORMAL);



	 
	SetTexture(Texture,TextureFileName);

}


void SpecialKeys(int key, int x, int y)
    {
    if(key == GLUT_KEY_UP)
        xRot-= 5.0f;

    if(key == GLUT_KEY_DOWN)
        xRot += 5.0f;

    if(key == GLUT_KEY_LEFT)
        dx -= 5.0f;

    if(key == GLUT_KEY_RIGHT)
        dx += 5.0f;

    if(key > 356.0f)
        xRot = 0.0f;

    if(key < -1.0f)
        xRot = 355.0f;

    if(key > 356.0f)
        yRot = 0.0f;

    if(key < -1.0f)
        yRot = 355.0f;

	if (key==GLUT_KEY_F1)
	{
	}
	if (key==GLUT_KEY_F2)
	{
		  static char file[256];
    static char fileTitle[256];
    //static char filter[] = "All Files (*.*)\0*.*\0";
    static OPENFILENAME ofn;

    lstrcpy( file, "");
    lstrcpy( fileTitle, "");

    ofn.lStructSize       = sizeof(OPENFILENAME);
    ofn.hwndOwner         = NULL;

    ofn.hInstance         = (HINSTANCE) GetModuleHandle(NULL);

    ofn.lpstrFilter       = "  \0*.tga";
    ofn.lpstrCustomFilter = (LPSTR) NULL;
    ofn.nMaxCustFilter    = 0L;
    ofn.nFilterIndex      = 1L;
    ofn.lpstrFile         = file;
    ofn.nMaxFile          = sizeof(file);
    ofn.lpstrFileTitle    = fileTitle;
    ofn.nMaxFileTitle     = sizeof(fileTitle);
    ofn.lpstrInitialDir   = NULL;
    ofn.lpstrTitle        = " ";
    ofn.nFileOffset       = 0;
    ofn.nFileExtension    = 0;
    ofn.lpstrDefExt       = "*";
    ofn.lCustData         = 0;

    ofn.Flags =  OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST |OFN_NOCHANGEDIR ;

    if (GetOpenFileName(&ofn))
	{
		free(TextureFileName);
		SetTexture(Texture,ofn.lpstrFile);
		TextureFileName=strdup(ofn.lpstrFile);
	}
;

	}

	if (key==GLUT_KEY_F3)
	{
		filtr=0;
		Anisotropic_filter();
		SetTexture(Texture,TextureFileName);

	}
	if (key==GLUT_KEY_F4)
	{
		filtr=1;
		Trilinein_filter();
		SetTexture(Texture,TextureFileName);
	}

	if (key==GLUT_KEY_F5)
	{
		filtr=2;
		Bilinein_filter();
		SetTexture(Texture,TextureFileName);
	}
	    // Refresh the Window
    glutPostRedisplay();
    }


void ChangeSize(int w, int h)
    {
    GLfloat fAspect;

    // Prevent a divide by zero
    if(h == 0)
        h = 1;

  
    // Set Viewport to window dimensions
    glViewport(0, 0, w, h);

    // Reset coordinate system
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    fAspect = (GLfloat)w/(GLfloat)h;
    gluPerspective(60.0f, fAspect, 200.0, 5000.0);

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    // Move out Z axis so we can see everything
    glTranslatef(0.0f, 0.0f, -350.0f);
    glLightfv(GL_LIGHT0,GL_POSITION,lightPos);
    }

void OnTimer(int )
{
	/*theta += 0.5f;
	if (theta > 360)
		theta = 0.0f;
	alpha += 0.6f;
	if (alpha > 360)
		alpha = 0.0f;
	dy += ddz;
	if ((dy > 20) || (dy < -20))
		ddz = -ddz;
*/
	 // Redraw the scene
    glutPostRedisplay();
    
    // Reset timer
    glutTimerFunc(1,OnTimer, 1);
	
}

int main(int argc, char* argv[])
    {
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
    glutInitWindowSize(800, 600);
    glutCreateWindow("Shadow");
    glutReshapeFunc(ChangeSize);
    glutSpecialFunc(SpecialKeys);
    glutDisplayFunc(RenderScene);
	 glutTimerFunc(10, OnTimer, 1);
    SetupRC();
    glutMainLoop();

    return 0;
    }
